package com.tzld.piaoquan.wecom.utils;

import com.alibaba.fastjson.JSONObject;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.codec.binary.Base64;

import javax.crypto.Mac;
import javax.crypto.spec.SecretKeySpec;
import java.nio.charset.StandardCharsets;
import java.security.InvalidKeyException;
import java.security.NoSuchAlgorithmException;

@Slf4j
public class LarkRobotUtil {

    private static final String SECRET = "iYGMzvTCIIX35WyPlxB3Lh";

    private static final String URL = "https://open.feishu.cn/open-apis/bot/v2/hook/5cab8414-03c2-4300-83f4-709cec256d12";

    private static final HttpPoolClient httpPoolClientDefault = HttpClientUtil.create(30000, 30000, 2000, 5000, 5, 30000);


    public static void sendMessage(String msg) {
        sendMessage("text", msg);
    }

    public static void sendMessage(String type, String msg) {
        try {
            long timestamp = System.currentTimeMillis() / 1000;
            String sign = getSign(timestamp);
            JSONObject param = new JSONObject();
            param.put("timestamp", String.valueOf(timestamp));
            param.put("sign", sign);
            param.put("msg_type", type);
            JSONObject content = new JSONObject();
            content.put("text", msg);
            param.put("content", content);
            httpPoolClientDefault.post(URL, param.toJSONString());
        } catch (Exception e) {
            log.error("Lark sendMessage error", e);
        }
    }


    private static String getSign(long timestamp) throws NoSuchAlgorithmException, InvalidKeyException {
        //把timestamp+"\n"+密钥当做签名字符串
        String stringToSign = timestamp + "\n" + SECRET;
        //使用HmacSHA256算法计算签名
        Mac mac = Mac.getInstance("HmacSHA256");
        mac.init(new SecretKeySpec(stringToSign.getBytes(StandardCharsets.UTF_8), "HmacSHA256"));
        byte[] signData = mac.doFinal(new byte[]{});
        return new String(Base64.encodeBase64(signData));
    }


}
